
//
// To jest przykładowy kod z podrozdziału 10.6 „Obsługa błędów wejścia i wyjścia” książki 
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include "std_lib_facilities.h"

//------------------------------------------------------------------------------

void fill_vector(istream& ist, vector<int>& v, char terminator)
// Wczytuje liczby całkowite ze strumienia ist do wektora v do chwili napotkania eof() lub znaku oznaczającego koniec danych.
{
    int i = 0;
    while (ist >> i) v.push_back(i);
    if (ist.eof()) return;    // Dobrze: znaleziono koniec pliku.

    // Nie good(), nie bad() i nie eof(), a więc ist musi być w stanie fail().
    ist.clear();              // Czyści stan strumienia.
    char c;
    ist>>c;                   // Wczytanie znaku z nadzieją, że to znak kończący.

    if (c != terminator) {    // Nie znak kończący, będzie niepowodzenie.
        ist.unget();          // Może wywołujący będzie wiedział, co zrobić z tym znakiem.
        ist.clear(ios_base::failbit); // Ustawia stan na fail().
    }
}

//------------------------------------------------------------------------------

int main()
try
{
    cin.exceptions(cin.exceptions()|ios_base::badbit);

    vector<int> v;
    fill_vector(cin, v, '*');
}
catch (exception& e) {
    cerr << "Błąd: " << e.what() << '\n'; 
    return 1;
}
catch (...) {
    cerr << "Nieznany wyjątek!\n"; 
    return 2;
}

//------------------------------------------------------------------------------
